#include <cstdio>
#include <cstdlib>
#include <string>
#include <windows.h>
#include <psapi.h>
using namespace std;


/* Slightly modified code snippet from MSDN (http://msdn.microsoft.com/en-us/library/ms682623(VS.85).aspx) */
DWORD PrintProcessNameAndID( DWORD processID, const char* targetName )
{
  TCHAR szProcessName[MAX_PATH] = TEXT("<unknown>");

  // Get a handle to the process.
  HANDLE hProcess = OpenProcess( PROCESS_QUERY_INFORMATION |
                                 PROCESS_VM_READ,
                                 FALSE, processID );

  // Get the process name.
  if(hProcess!=NULL)
  {
    HMODULE hMod;
    DWORD cbNeeded;

    if ( EnumProcessModules(hProcess,&hMod,sizeof(hMod), 
         &cbNeeded) )
    {
      GetModuleBaseName( hProcess, hMod, szProcessName, 
                         sizeof(szProcessName)/sizeof(TCHAR) );
    }
  }
  CloseHandle( hProcess );

  if(!_stricmp(szProcessName,targetName)) return processID;  
  return -1;
}

DWORD FindProcessId(const char* targetName)
{
  // Get the list of process identifiers.
  DWORD aProcesses[1024], cbNeeded, cProcesses;
  DWORD foundPID;
  unsigned int i;

  if(!EnumProcesses(aProcesses,sizeof(aProcesses),&cbNeeded)) return -1;

  // Calculate how many process identifiers were returned.
  cProcesses = cbNeeded / sizeof(DWORD);

  // Print the name and process identifier for each process.
  for ( i = 0; i < cProcesses; i++ )
  {
    if( aProcesses[i] != 0 )
    {
      foundPID = PrintProcessNameAndID(aProcesses[i],targetName);
      if(foundPID!=-1) return foundPID;
    }
  }

  return -1;
}

bool InjectDll (HANDLE hProcess, const char* pLibName)
{
  DWORD ExitCode;
  FARPROC LoadLib = GetProcAddress (GetModuleHandle ("kernel32.dll"), "LoadLibraryA");

  void* pMem = VirtualAllocEx (hProcess, 0, MAX_PATH, MEM_COMMIT, PAGE_READWRITE);
  WriteProcessMemory(hProcess, pMem, pLibName, lstrlen (pLibName), 0);

  HANDLE hThread = CreateRemoteThread (hProcess, 0, 0, (LPTHREAD_START_ROUTINE) LoadLib, pMem, 0, &ExitCode);
 
  return (hThread!=NULL);
};


int main()
{
  UINT ExplorerPID = FindProcessId("explorer.exe");
  if(ExplorerPID == (UINT)-1)
  {
    puts("Cannot find the explorer.exe process! ;<");
    return 1;
  }

  HANDLE hExplorer = OpenProcess(PROCESS_ALL_ACCESS,false,ExplorerPID);
  if(!InjectDll(hExplorer,"C:\\dbg.dll"))
  {
    puts("Unable to inject code into explorer.exe!");
    return 1;
  }
  puts("Done.");

  return 0;
}

