#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <psapi.h>

static BOOL bInitialized = FALSE;

LRESULT CALLBACK KeyboardProc(
  int nCode,
  WPARAM wParam,
  LPARAM lParam
)
{
  return CallNextHookEx( (HHOOK)0, nCode, wParam, lParam );
}

BOOL InstallHook()
{
  // set the sytem-wide hook on startup
  if(SetWindowsHookEx(WH_KEYBOARD,(HOOKPROC)KeyboardProc,GetModuleHandle("HOOK"),0) == NULL)
  {
    return FALSE;
  }
  
  return TRUE;
}


/* Slightly modified code snippet from MSDN (http://msdn.microsoft.com/en-us/library/ms682623(VS.85).aspx) */
BOOL PrintProcessNameAndID( DWORD processID, char* targetName )
{
  TCHAR szProcessName[MAX_PATH] = TEXT("<unknown>");

  // Get a handle to the process.
  HANDLE hProcess = OpenProcess( PROCESS_QUERY_INFORMATION |
                                 PROCESS_VM_READ,
                                 FALSE, processID );

  // Get the process name.
  if(hProcess!=NULL)
  {
    HMODULE hMod;
    DWORD cbNeeded;

    if ( EnumProcessModules(hProcess,&hMod,sizeof(hMod), 
         &cbNeeded) )
    {
      GetModuleBaseName( hProcess, hMod, szProcessName, 
                         sizeof(szProcessName)/sizeof(TCHAR) );
    }
  }
  CloseHandle( hProcess );

  if(!_stricmp(szProcessName,targetName)) return TRUE;  
  return FALSE;
}

BOOL IsProcessActive(char* targetName)
{
  // Get the list of process identifiers.
  DWORD aProcesses[1024], cbNeeded, cProcesses;
  unsigned int i;

  if(!EnumProcesses(aProcesses,sizeof(aProcesses),&cbNeeded))
        return 1;

  // Calculate how many process identifiers were returned.
  cProcesses = cbNeeded / sizeof(DWORD);

  // Print the name and process identifier for each process.
  for ( i = 0; i < cProcesses; i++ )
      if( aProcesses[i] != 0 )
          if(PrintProcessNameAndID(aProcesses[i],targetName)) return TRUE;

  return FALSE;
}



BOOL WINAPI DllMain(
  HANDLE hinstDLL, 
  DWORD dwReason, 
  LPVOID lpvReserved
)
{
  if(dwReason == DLL_PROCESS_DETACH)
  {
    // if the process has just been killed, re-create it now
    if(!IsProcessActive("a.exe"))
    {
      STARTUPINFO si;
      PROCESS_INFORMATION pi;

      memset(&pi,0,sizeof(pi));
      memset(&si,0,sizeof(si));
      si.cb = sizeof(si);

      CreateProcess(NULL,"C:\\a.exe",NULL,NULL,TRUE,0,NULL,NULL,&si,&pi);
    }
  }

  return TRUE;
}

